package instrumento;

public abstract class Instrumento {
    /* abstracta por dos razones:
     * -para que no se pueda instanciar
     * -porque hay 1 mtodo abstract */
    protected String familia;
    /* protected: porque hay clases derivadas en otro paquete 
       que necesitan acceder a este atributo */
    protected String nombre;
	private static int numInstrumentosCreados;
    /* private: para que ninguna otra clase pueda modificar
       el valor */
    
    protected Instrumento() {
	numInstrumentosCreados ++;
    }
    
    protected static void numInstrumentosCreados() {
	System.out.println(numInstrumentosCreados);
    }
    
    protected abstract void musicoFamoso();
    /* abstract: 2 razones:
     * 1. Para forzar a las clases hijas a implementarlo 
     *    (o si no habrn de ser abstract)
     * 2. Porque no queremos almacenar un atributo musicoFamoso */	
    
    protected void info() { /* accesible para las hijas */
	System.out.println("Instrumento: "+nombre + "   Familia: "+familia);
    }
}

