package trompeta;
import instrumento.*;

final class Fagot extends Viento {
    /*final: no se quiere que haya subclases de fagot */
    public Fagot() {
	/* super(); no es necesaria porque por defecto la llama */
	nombre="Fagot";
    }
    
    public void musicoFamoso() {
	System.out.println("Ni idea");
    }
    
    protected void info() {
	/* -Si se omite este mtodo dara error, porque se intenta
	   acceder desde la clase Trompeta a un mtodo protected
	   de una clase hermana (pero no antepasada) Fagot.
	   -Y si fuese private o friendly (vaco) dara error porque
	   sera ms restrictivo que el mtodo de la clase madre*/
	super.info(); // Omitido no saldra la info por pantalla
    }
}

public class Trompeta extends Viento {
    /*no es 'final': podra haber subclases de trompeta
      ej. tropeta pcolo, trompeta bajo,... */
    public Trompeta() {
	super(); /* es opcional porque por defecto la llama */
	nombre="Trompeta";
    }
    
    public void musicoFamoso() {
	System.out.println("Miles Davis");
    }
    
    public static void main (String[] args) {
	Trompeta t1 = new Trompeta();
	t1.info();
	Trompeta t2 = new Trompeta();
	t2.info();
	
	Fagot f1 = new Fagot();
	f1.info();
	
	/* t1.numInstrumentosCreados(); dara warning por intentar
	   acceder a un mtodo static*/
	numInstrumentosCreados();
    }
    
}
